require('./sourcemap-register.js');module.exports =
/******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ 880:
/***/ ((__unused_webpack_module, exports) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.isIdentifierChar = exports.isIdentifierStart = void 0;
exports.isIdentifierStart = function (code) {
    if (code < 65)
        return code === 36; // $
    if (code < 91)
        return true; // A-Z
    if (code < 97)
        return code === 95; // _
    return code < 123; // `a-z`
};
exports.isIdentifierChar = function (code) {
    if (code < 45)
        return code === 36; // $
    if (code < 48)
        return code === 45; // -
    if (code < 58)
        return true; // 0-9
    if (code < 65)
        return false;
    if (code < 91)
        return true; // A-Z
    if (code < 97)
        return code === 95; // _
    return code < 123; // `a-z`
};


/***/ }),

/***/ 109:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.x = exports.xpath2css = exports.isXPath = exports.parse = void 0;
const parser_1 = __importDefault(__webpack_require__(267));
const to_selector_1 = __importDefault(__webpack_require__(934));
exports.parse = (query) => new parser_1.default(query).parse();
exports.isXPath = (query) => {
    try {
        exports.parse(query);
        return true;
    }
    catch (e) {
        return false;
    }
};
exports.xpath2css = (query) => to_selector_1.default(exports.parse(query));
exports.default = exports.xpath2css;
exports.x = (arg, ...param) => {
    if (arg.length <= 1) {
        return exports.xpath2css(arg[0]);
    }
    let query = arg[0];
    for (let i = 1; i < arg.length; i++) {
        query += String(param[i - 1]);
        query += arg[i];
    }
    return exports.xpath2css(query);
};


/***/ }),

/***/ 267:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const tokentype_1 = __importStar(__webpack_require__(597));
const identifier_1 = __webpack_require__(880);
const isNewLine = function (code) {
    return code === 10 || code === 13 || code === 0x2028 || code === 0x2029;
};
class Parser {
    constructor(query) {
        this.input = String(query);
        this.pos = 0;
        this.start = 0;
        this.end = 0;
        this.type = tokentype_1.default.eof;
        this.value = undefined;
        this.lastTokStart = this.pos;
        this.lastTokEnd = this.pos;
    }
    /**
     * Exception handling
     */
    raise(pos, msg) {
        msg += " (" + pos + ")";
        const err = new SyntaxError(msg);
        err.pos = pos;
        throw err;
    }
    next() {
        this.lastTokEnd = this.end;
        this.lastTokStart = this.start;
        return this.nextToken();
    }
    // tokenizer
    nextToken() {
        this.skipSpace();
        this.start = this.pos;
        if (this.pos >= this.input.length) {
            return this.finishToken(tokentype_1.default.eof);
        }
        return this.readToken(this.fullCharCodeAtPos());
    }
    readToken(code) {
        if (identifier_1.isIdentifierStart(code)) {
            return this.readWord();
        }
        return this.getTokenFromCode(code);
    }
    fullCharCodeAtPos() {
        const code = this.input.charCodeAt(this.pos);
        return code;
    }
    skipSpace() {
        loop: while (this.pos < this.input.length) {
            const ch = this.input.charCodeAt(this.pos);
            switch (ch) {
                case 32:
                case 160: // ' '
                    ++this.pos;
                    break;
                case 13: // CR
                    if (this.input.charCodeAt(this.pos + 1) === 10) {
                        ++this.pos;
                    }
                case 10:
                case 8232:
                case 8233: // eslint-disable-line no-fallthrough
                    this.raise(this.pos, "Unexpected newline character");
                default:
                    if (ch > 8 && ch < 14) {
                        ++this.pos;
                    }
                    else {
                        break loop;
                    }
            }
        }
    }
    readTokenSlash() {
        const next = this.input.charCodeAt(this.pos + 1);
        if (next === 47) {
            const str = this.input.slice(this.pos, (this.pos += 2));
            return this.finishToken(tokentype_1.default.doubleSlash, str);
        }
        const str = this.input.slice(this.pos, (this.pos += 1));
        return this.finishToken(tokentype_1.default.slash, str);
    }
    getTokenFromCode(code) {
        switch (code) {
            case 40:
                ++this.pos;
                return this.finishToken(tokentype_1.default.parenL);
            case 41:
                ++this.pos;
                return this.finishToken(tokentype_1.default.parenR);
            case 44:
                ++this.pos;
                return this.finishToken(tokentype_1.default.comma);
            case 91:
                ++this.pos;
                return this.finishToken(tokentype_1.default.bracketL);
            case 93:
                ++this.pos;
                return this.finishToken(tokentype_1.default.bracketR);
            // Numbers
            case 48:
            case 49:
            case 50:
            case 51:
            case 52:
            case 53:
            case 54:
            case 55:
            case 56:
            case 57:
                return this.readNumber();
            // String
            case 34:
            case 39:
                return this.readString(code);
            case 47: // '/'
                return this.readTokenSlash();
            case 124:
                ++this.pos; // '|'
                return this.finishToken(tokentype_1.default.pipe);
            case 42:
                ++this.pos; // '*'
                return this.finishToken(tokentype_1.default.star);
            case 64:
                ++this.pos; // '@'
                return this.finishToken(tokentype_1.default.at);
            case 61:
                ++this.pos; // '='
                return this.finishToken(tokentype_1.default.eq);
            default:
                this.raise(this.pos, 'Unexpected character "' + this.input[this.pos] + '"');
        }
    }
    finishToken(type, val) {
        this.end = this.pos;
        this.type = type;
        this.value = val;
    }
    /**
     * Read an integer in the given radix. Return null if zero digits
     * were read, the integer value otherwise. When `len` is given, this
     * will return `null` unless the integer has exactly `len` digits.
     */
    readInt(radix, len = null) {
        const start = this.pos;
        let total = 0;
        let e = (len === null ? Infinity : len);
        for (let i = 0; i < e; ++i) {
            const code = this.fullCharCodeAtPos();
            let val;
            if (code >= 97) {
                val = code - 97 + 10; // `a`
            }
            else if (code >= 65) {
                val = code - 65 + 10; // A
            }
            else if (code >= 48 && code <= 57) {
                val = code - 48; // 0-9
            }
            else {
                val = Infinity;
            }
            if (val >= radix) {
                break;
            }
            ++this.pos;
            total = total * radix + val;
        }
        if (this.pos === start || (len !== null && this.pos - start !== len)) {
            return null;
        }
        return total;
    }
    readNumber() {
        const start = this.pos;
        if (this.readInt(10) === null) {
            this.raise(start, "Invalid Number");
        }
        let next = this.fullCharCodeAtPos();
        if (next === 46) {
            // '.'
            ++this.pos;
            this.readInt(10);
            next = this.fullCharCodeAtPos();
        }
        if (next === 69 || next === 101) {
            // `eE`
            next = this.input.charCodeAt(++this.pos);
            if (next === 43 || next === 45) {
                ++this.pos; // +/-
            }
            if (this.readInt(10) === null) {
                this.raise(start, "Invalid number");
            }
        }
        if (identifier_1.isIdentifierStart(this.fullCharCodeAtPos())) {
            this.raise(this.pos, "Identifier directly after number");
        }
        const str = this.input.slice(start, this.pos);
        return this.finishToken(tokentype_1.default.num, str);
    }
    readString(quote) {
        let out = "";
        const start = this.start;
        let chunkStart = ++this.pos;
        for (;;) {
            if (this.pos >= this.input.length) {
                this.raise(start, "Unterminated string");
            }
            const ch = this.fullCharCodeAtPos();
            if (ch === quote) {
                break;
            }
            if (ch === 92) {
                // '\' escape
                out += this.input.slice(chunkStart, this.pos);
                out += this.readEscapedChar();
                chunkStart = this.pos;
            }
            else {
                if (isNewLine(ch)) {
                    this.raise(start, "Unterminated string");
                }
                ++this.pos;
            }
        }
        out += this.input.slice(chunkStart, this.pos++);
        return this.finishToken(tokentype_1.default.string, out);
    }
    readEscapedChar() {
        const ch = this.input.charCodeAt(++this.pos);
        ++this.pos;
        switch (ch) {
            case 110:
                return "\n";
            case 114:
                return "\r";
            case 116:
                return "\t";
            case 98:
                return "\b";
            case 118:
                return "\u000b"; // eslint-disable-line unicorn/escape-case
            case 102:
                return "\f";
            case 13:
                if (this.fullCharCodeAtPos() === 10) {
                    ++this.pos; // '\r\n'
                }
            case 10:
                return ""; // eslint-disable-line no-fallthrough
            default:
                return String.fromCharCode(ch);
        }
    }
    readWord1() {
        const chunkStart = this.pos;
        while (this.pos < this.input.length) {
            const ch = this.fullCharCodeAtPos();
            if (identifier_1.isIdentifierChar(ch)) {
                ++this.pos;
            }
            else {
                break;
            }
        }
        const word = this.input.slice(chunkStart, this.pos);
        return word;
    }
    readWord() {
        const word = this.readWord1();
        if (tokentype_1.keywords[word]) {
            return this.finishToken(tokentype_1.keywords[word], word);
        }
        return this.finishToken(tokentype_1.default.name, word);
    }
    startNode() {
        return {
            type: "",
            start: this.start,
            end: 0,
        };
    }
    finishNode(node, type) {
        node.type = type;
        node.end = this.lastTokEnd;
        return node;
    }
    parse() {
        this.nextToken();
        return this.parseTopLevel();
    }
    parseTopLevel() {
        const steps = [];
        while (this.type !== tokentype_1.default.eof) {
            const step = this.parseStep();
            steps.push(step);
        }
        return steps;
    }
    parseStep() {
        const node = this.startNode();
        node.axis = this.parseAxis();
        node.nodeTest = this.parseNodeTest();
        node.predicate = this.parseFilters();
        return this.finishNode(node, "step");
    }
    parseAxis() {
        const type = this.type;
        if (type === tokentype_1.default.doubleSlash) {
            this.next();
            return tokentype_1.default.doubleSlash;
        }
        else if (type === tokentype_1.default.slash) {
            this.next();
            return tokentype_1.default.slash;
        }
        else {
            this.raise(this.start, "Expect an axis");
        }
    }
    parseNodeTest() {
        const node = this.startNode();
        const type = this.type;
        if (type === tokentype_1.default.star) {
            node.value = "*";
            this.next();
            return this.finishNode(node, "nodeTest");
        }
        else if (type === tokentype_1.default.name) {
            return this.parseTag(node);
        }
        else {
            this.raise(this.start, "Expect a node test");
        }
    }
    parseTag(node) {
        node.value = this.value;
        this.next();
        if (this.type === tokentype_1.default.parenL) {
            this.raise(this.start, "Unexpected xpath function");
        }
        return this.finishNode(node, "nodeTest");
    }
    parseFilters() {
        const filters = [];
        while (this.eat(tokentype_1.default.bracketL)) {
            const filter = this.parsePredicate();
            filters.push(filter);
            if (filter.type !== "positionFilter" && this.eat(tokentype_1.default.and)) {
                const filter2 = this.parsePredicate();
                filters.push(filter2);
            }
            this.expect(tokentype_1.default.bracketR);
        }
        return filters;
    }
    parsePredicate() {
        const node = this.startNode();
        const type = this.type;
        switch (type) {
            case tokentype_1.default.at:
                return this.parseAttrFilter(node);
            case tokentype_1.default.name:
                return this.parseMaybeFun(node);
            case tokentype_1.default.num:
                node.position = this.value;
                this.next();
                return this.finishNode(node, "positionFilter");
            default:
                this.raise(this.start, "Unexpected node predicate");
        }
    }
    parseAttrFilter(node) {
        this.next();
        // @attr
        node.attr = this.getName();
        this.expect(tokentype_1.default.eq);
        node.value = this.getString();
        return this.finishNode(node, "attributeFilter");
    }
    parseFunction(node) {
        this.next();
        node.arg = this.parseBindingList(tokentype_1.default.parenR);
        return this.finishNode(node, "function");
    }
    // ## Parser utilities
    eat(type) {
        if (this.type === type) {
            this.next();
            return true;
        }
        return false;
    }
    expect(type) {
        return (this.eat(type) ||
            this.raise(this.lastTokEnd, `Expect a "${type.label}" after, got ${this.type.label}`));
    }
    getName() {
        if (this.type !== tokentype_1.default.name) {
            this.raise(this.start, "Expect a valid name");
        }
        const val = this.value;
        this.next();
        return val;
    }
    getString() {
        if (this.type !== tokentype_1.default.string) {
            this.raise(this.start, "Expect a string");
        }
        const val = this.value;
        this.next();
        return val;
    }
    parseBindingList(close) {
        const elts = [];
        let first = true;
        while (!this.eat(close)) {
            if (first) {
                first = false;
            }
            else {
                // (1, ...)
                this.expect(tokentype_1.default.comma);
            }
            const el = this.parseArg();
            elts.push(el);
        }
        return elts;
    }
    parseArg() {
        const node = this.startNode();
        const type = this.type;
        switch (type) {
            case tokentype_1.default.name:
                return this.parseMaybeFun(node);
            case tokentype_1.default.string:
                node.name = this.getString();
                return this.finishNode(node, "string");
            case tokentype_1.default.at:
                this.next();
                node.attr = this.getName();
                return this.finishNode(node, "attribute");
            default:
                this.raise(this.start, "Unexpected function argument");
        }
    }
    parseMaybeFun(node) {
        node.name = this.getName();
        // position function have its arguments like this
        // position() = 2
        if (node.name === "position") {
            this.expect(tokentype_1.default.parenL);
            this.expect(tokentype_1.default.parenR);
            this.expect(tokentype_1.default.eq);
            const type = this.type;
            if (type !== tokentype_1.default.num) {
                this.raise(this.start, `Expect a number for position function, got ${this.type.label}.`);
            }
            node.position = this.value;
            this.next();
            return this.finishNode(node, "function");
        }
        // normal functions(arg1, arg2...)
        if (this.type === tokentype_1.default.parenL) {
            return this.parseFunction(node);
        }
        return this.finishNode(node, "name");
    }
}
exports.default = Parser;


/***/ }),

/***/ 934:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const tokentype_1 = __importDefault(__webpack_require__(597));
function axisToStr(axis, isFirst) {
    if (isFirst) {
        return "";
    }
    if (axis === tokentype_1.default.doubleSlash) {
        // child or descendent
        return " ";
    }
    else if (axis === tokentype_1.default.slash) {
        return " > ";
    }
    throw Error("!Unexpected axis");
}
function nodeTestToStr(node) {
    if (node.value === "*") {
        return "";
    }
    return node.value || "";
}
function attrFilterToStr(node) {
    const attr = node.attr;
    if (attr === "id") {
        return `#${node.value}`;
    }
    else if (attr === "class") {
        return `.${node.value}`;
    }
    else {
        return `[${attr}="${node.value}"]`;
    }
}
function xpathFuncToStr(node) {
    switch (node.name) {
        case "contains":
            return containsToStr(node);
        case "position":
            return positionToStr(node);
        default:
            throw new Error(`Unsupported function: ${node.name}`);
    }
}
function positionToStr(node) {
    return `:nth-child(${node.position})`;
}
function containsToStr(node) {
    if (!node.arg) {
        throw new Error(`No arguments for function: ${node.name}`);
    }
    if (node.arg.length !== 2) {
        throw new Error("Expect contains function to have 2 arguments");
    }
    if (node.arg[0].name === "text") {
        return `:contains(${node.arg[1].name})`;
    }
    if (node.arg[0].type === "attribute") {
        return `[${node.arg[0].attr}*=${node.arg[1].name}]`;
    }
    throw new Error(`Unsupported function: ${node.arg[0].type}`);
}
function predicateToStr(node) {
    switch (node.type) {
        case "positionFilter":
            return `:nth-child(${node.position})`;
        case "attributeFilter":
            return attrFilterToStr(node);
        case "function":
            return xpathFuncToStr(node);
        case "name":
            return `:has(${node.name})`;
        default:
            throw new Error("!Unhandled predicate");
    }
}
function stepToSel(step, index) {
    const axis = axisToStr(step.axis, index === 0);
    const nodeTest = nodeTestToStr(step.nodeTest);
    const predicate = (step.predicate || []).map(predicateToStr);
    return axis + nodeTest + predicate.join("");
}
function xpath2css(steps) {
    const selectorList = steps.map(stepToSel);
    return selectorList.join("");
}
exports.default = xpath2css;


/***/ }),

/***/ 597:
/***/ ((__unused_webpack_module, exports) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.keywords = exports.TokenType = void 0;
class TokenType {
    constructor(label, options = {}) {
        this.label = label;
        this.beforeExpr = Boolean(options.beforeExpr);
    }
}
exports.TokenType = TokenType;
exports.keywords = {};
function kw(name, options = {}) {
    options.keyword = name;
    const tt = new TokenType(name, options);
    exports.keywords[name] = tt;
    return tt;
}
const types = {
    num: new TokenType("num"),
    string: new TokenType("string"),
    name: new TokenType("name"),
    eof: new TokenType("eof"),
    // Operators
    bracketL: new TokenType("["),
    bracketR: new TokenType("]"),
    parenL: new TokenType("("),
    parenR: new TokenType(")"),
    pipe: new TokenType("|"),
    slash: new TokenType("/"),
    doubleSlash: new TokenType("//"),
    star: new TokenType("*"),
    at: new TokenType("@"),
    eq: new TokenType("="),
    comma: new TokenType(","),
    and: kw("and", { beforeExpr: true }),
};
exports.default = types;


/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		if(__webpack_module_cache__[moduleId]) {
/******/ 			return __webpack_module_cache__[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		var threw = true;
/******/ 		try {
/******/ 			__webpack_modules__[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/ 			threw = false;
/******/ 		} finally {
/******/ 			if(threw) delete __webpack_module_cache__[moduleId];
/******/ 		}
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/compat */
/******/ 	
/******/ 	__webpack_require__.ab = __dirname + "/";/************************************************************************/
/******/ 	// module exports must be returned from runtime so entry inlining is disabled
/******/ 	// startup
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(109);
/******/ })()
;
//# sourceMappingURL=index.js.map